import fr.umlv.sprintabout.*;

import java.util.Random;

public class StressTest { 
  
  interface H {
  }
  
  private static long time(ConcurrentIntMap map,Object[] objects,int max) {
    Random random=new Random();
    
    long time=System.nanoTime();
    for(int i=0;i<10000000;i++) {
      int index=random.nextInt(max);
      if (map.get(objects[index].getClass())!=index)
        throw new AssertionError();
    }
    return System.nanoTime()-time;
  }
  
  private static void time(Object[] objects) {
    for(int i=1;i<objects.length;i++) {
      
      // prepare map
      ConcurrentIntMap map=new ConcurrentIntMap(i);
      for(int j=0;j<i;j++)
        map.insert(objects[j].getClass(),j);
      
      System.out.println(time(map,objects,i));
    }
  }
  
  public static void main(String[] args) throws Exception{
    Object[] objects=new Object[] {
      new H() {}, new H() {}, new H() {}, new H() {},
      new H() {}, new H() {}, new H() {}, new H() {},
      new H() {}, new H() {}, new H() {}, new H() {},
      new H() {}, new H() {}, new H() {}, new H() {},
      new H() {}, new H() {}, new H() {}, new H() {},
      new H() {}, new H() {}, new H() {}, new H() {},
      new H() {}, new H() {}, new H() {}, new H() {},
      new H() {}, new H() {}, new H() {}, new H() {},
      new H() {}, new H() {}, new H() {}, new H() {},
      new H() {}, new H() {}, new H() {}, new H() {}
    };
    
    time(objects);
  }
} 


