package test;

import fr.umlv.sprintabout.VisitorGenerator;

//argument types hierarchy
interface A {}
class A0 implements A {}
class A1 implements A {}
class A2 implements A {}

public abstract class SumSprintabout {
  public int value(A0 a) { return 0; }
  public int value(A1 a) { return 1; }
  public int value(A2 a) { return 2; }
  public abstract int valueAppropriate(A a);
  public static int sum(A[] array) {
    int sum = 0;
    VisitorGenerator vg = new VisitorGenerator();
    SumSprintabout visitor = vg.createVisitor(SumSprintabout.class);
    for (int i=0; i<array.length; i++) {
      sum += visitor.valueAppropriate(array[i]);
    }
    return sum;
  }
  public static void main(String[] args) throws Exception {
    A[] array = {new A0(), new A1(), new A2() };
    System.out.println(sum(array)); 
  }
} // end SumSprintabout
