
/*
 * Created on 28 avr. 2004
 *
 */
package test;

import java.util.Random;
import fr.umlv.sprintabout.*;

/**
 * @author remi
 *
 */
public abstract class Main {

  public void m(String s) {
    //System.out.println("String "+s);
  }
  
  public void m(Object o) {
    //System.out.println("Object "+o);
  }
  
  public void m(Integer i) {
    //System.out.println("Integer "+i);
  }
  
  public void m(Double d) {
    //System.out.println("Double "+d);
  }
  
  public abstract void mAppropriate(Object o);
  
  public static void main(String[] args) {
    VisitorGenerator vg=new VisitorGenerator();
    Main main=vg.createVisitor(Main.class);
    
    Object[] array={new Object(),"toto",3,4.2};
    
    Random random=new Random();
    long time=System.nanoTime();
    for(int i=0;i<1000000;i++)
      main.mAppropriate(array[random.nextInt(3)]);
    long time2=System.nanoTime();
    System.out.println((time2-time)/1000000.0+" ns");
  }
}
